.386
.model flat,stdcall
option casemap:none

    include \masm32\include\windows.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc

    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib

.data
    msgFailed      db  'procedure failed',13,10,0
    msgSuccess     db  'procedure suceeded',13,10,0
    str1           db  'This is a lnoong string, more than 100 chars, and at position #100 the pattern we are looking for: deniz', 0
    str2           db  'deniz', 0
    prnCh          db  '%c',0
    prnNo          db  '%d',0
    prnStr         db  '%s',0
    len1           db  0
    len2           db  0
    tval           db  0
    ppos           DD  0
    
.code
start:
    xor bx, bx              ;Zero bx
    mov esi, offset str1
                            ;Get the length of str1 and save it to bl
repeatstr1:                 ;repeat until the end of str1
    mov al, [esi]
    inc esi
    inc bl
    cmp al, 0
    jnz repeatstr1
    mov len1, bl            ; save str1 length
                            ;Get the length of str2 and save it to bh
    mov esi, offset str2
repeatstr2:                 ;repeat until the end of str2
    mov al, [esi]
    inc esi
    inc bh
    cmp al, 0
    jnz repeatstr2
    mov len2, bh            ; save str2 length
    dec len1                ;there will be no need to compare '0'
    dec len2
    mov cl, 1
; ------------------------------  begin compare

    mov esi, offset str1       ; main string
Label0:
    mov edi, offset str2       ; test string
    mov ah, [edi]              ; first char in test string
Label1:
    mov al, [esi]              ; first character in main string
    cmp al, ah
    jz Label2                  ; I have an equal
    cmp al, 0
    jz NotFound
    inc esi
    inc cl
    jmp Label1
;
Label2: 
    mov tval, cl           ; char counter main string
    mov ppos, esi          ; save pointer
    mov bl, len2           ; get length of test string
;
Label3:
    dec bl
    cmp bl, 0
    jz Found               ; we have a WINNER
    inc esi                ; no, next chr in main string
    inc edi                ; next chr in test string
    mov al, [esi]
    mov ah, [edi]          ; first char in test string
    cmp al, ah
    jz Label3              ; this char is equal, loop next
    mov bh, len1           ; Oops! not equal
    cmp bh, tval
    jz NotFound            ; fail, ran out of string
    mov esi, ppos          ; not done yet, loop again
    inc esi
    inc cl
    jmp Label0
;
NotFound:
    mov eax, 0
    mov ppos, eax
    invoke printf, addr prnStr, addr msgFailed
    jmp finish
Found: 	
    xor eax, eax
    mov al, tval
    mov ppos, eax
    invoke printf, addr prnStr, addr msgSuccess
finish:
    invoke printf, addr prnNo, ppos
    call _getch
    mov eax, ppos
    invoke ExitProcess, ppos
END start

